int helpCursor=0;

const char* const helpText[]={
	"Main controls",
	"",
	"",
	"Alt+Enter           Switch between windowed and fullscreen mode",
	"",
	"Left                Move cursor left",
	"Right               Move cursor right",
	"Tab, Shift+Tab      Move cursor to the next or previous channel",
	"",
	"Up                  Move cursor up one row",
	"Down                Move cursor down one row",
	"PageUp              Move cursor page up",
	"PageDown            Move cursor page down",
	"Ctrl+PageUp         Move cursor large page up",
	"Ctrl+PageDown       Move cursor large page down",
	"",
	"Backquote           Increment autostep",
	"Shift+Backquote     Decrement autostep",
	"",
	"Letter keys         Enter note",
	"1, A                Enter rest note",
	"Numbers             Enter numeric parameter",
	"\" (quote)           Repeat a previosly entered value",
	"Enter (hold)        Play song from current row",
	"8                   Play current row",
	"",
	"Delete              Clear a field under cursor or a selection",
	"Insert              Insert empty position into current channel with shift",
	"Backspace           Delete position of current channel with shift",
	"Ctrl+Insert         Insert an empty row with shift",
	"Ctrl+Delete         Delete a row with shift",
	"",
	"Space               Split song into a block",
	"Home                Move cursor to a previous block",
	"End                 Move cursor to a next block",
	"",
	"Ctrl+Home,Ctrl+N    Set loop start",
	"Ctrl+End, Ctrl+M    Set loop end",
	"",
	"Num *               Increment octave",
	"Num /               Decrement octave",
	"",
	"Shift+0..9, Numpad  Select octave",
	"",
	"Ctrl +, Num +       Increase global speed",
	"Ctrl -, Num -       Decrease global speed",
	"",
	"Ctrl+[              Increase measure",
	"Ctrl+]              Decrease measure",
	"",
	"Ctrl+0              Unmute all channels",
	"Ctrl+1..9           Toggle mute for channel 1-9",
	"Ctrl+Backquote      Mute all but current channel",
	"",
	"Shift+[Move]        Make a selection",
	"Ctrl+A              Select all channels between markers or the whole length",
	"Ctrl+L              Select current channel",
	"Ctrl+X              Cut selection",
	"Shift+X             Cut selection with shift",
	"Ctrl+C,Shift+C      Copy selection",
	"Ctrl+V              Paste selection",
	"Shift+V             Paste selection with shift",
	"Ctrl+E              Expand selection",
	"Ctrl+S              Shrink selection",
	"Ctrl+U              Transpose semitone up",
	"Ctrl+D              Transpose semitone down",
	"Ctrl+O              Transpose octave up",
	"Ctrl+K              Transpose octave down",
	"Ctrl+R              Replicate selection",
	"Ctrl+T              Exchange selected content between Main and Side tracks",
	"Ctrl+B,Shift+B      Blend content from other track (overwrite or into gaps)",
	"Ctrl+W              Unwind all notes within a selection filling the gaps",
	"",
	"Ctrl+F              Name current block",
	"Ctrl+G              Go to line",
	"Ctrl+Q,Shift+Q      Copy or insert an existing block by typing its name",
	"Ctrl+P              Find parent block from a reference block",
	"Ctrl+Shift+P        Update all reference blocks",
	"",
	"Ctrl+Z              Undo last change",
	"",
	"",
	"",
	"Instrument editor controls",
	"",
	"To get into the instrument editor, press F4 on the main screen. There you",
	"can switch between the instruments using + - or Numpad + -, select a",
	"parameter with the Up/Down keys, change a value using Left/Right arrows,",
	"or enter a value directly by pressing Enter. You can also switch between",
	"the channels using the Tab button."
};



void draw_help(void)
{
	for (int i = 0; i < textScreenWidth; ++i)
	{
		PUT_ATTR(i,0,COL_HEADER);
		PUT_ATTR(i,textScreenHeight-1,COL_HEADER);
	}

	put_str(1, 0, "Help :: " WINDOW_TITLE, COL_HEADER);
	put_str(1, textScreenHeight - 1, "Use ~Up/Down~ and ~PgUp/PgDown~", COL_HEADER);

	int y = 2 - helpCursor;
	int lines = sizeof(helpText) / sizeof(const char*);

	for (int i = 0; i < lines; ++i)
	{
		if (y >= 1 && y<textScreenHeight - 1) put_str(3, y, (char*)helpText[i], COL_PROGRAM_BACKGROUND);

		++y;
	}

	PUT_CHAR_ATTR(PATTERN_XPOS + 1, PATTERN_YPOS + 1, helpCursor ? 16 : ' ', COL_DIRECTORY);
	PUT_CHAR_ATTR(PATTERN_XPOS + 1, PATTERN_YPOS + 2, helpCursor ? 16 : ' ', COL_DIRECTORY);

	PUT_CHAR_ATTR(PATTERN_XPOS + 1, textScreenHeight - 3, helpCursor < (lines - textScreenHeight + 4) ? 17 : ' ', COL_DIRECTORY);
	PUT_CHAR_ATTR(PATTERN_XPOS + 1, textScreenHeight - 4, helpCursor < (lines - textScreenHeight + 4) ? 17 : ' ', COL_DIRECTORY);
}



void help_events(SDL_Event event)
{
	int max;

	switch(event.type)
	{
	case SDL_KEYDOWN:
		{
			switch(event.key.keysym.sym)
			{
			case SDLK_ESCAPE:
				{
					set_edit_mode(MODE_EDIT_SONG);
				}
				break;

			case SDLK_UP:
				{
					--helpCursor;
				}
				break;

			case SDLK_DOWN:
				{
					++helpCursor;
				}
				break;
			
			case SDLK_PAGEUP:
				{
					helpCursor-=(textScreenHeight-2);
				}
				break;

			case SDLK_PAGEDOWN:
				{
					helpCursor+=(textScreenHeight-2);
				}
				break;
			}
		}
		break;
	}

	max=sizeof(helpText)/sizeof(const char*)-(textScreenHeight-4);
	
	if(helpCursor<0) helpCursor=0;
	if(helpCursor>max) helpCursor=max;
}